﻿Imports System.Runtime.InteropServices
Imports System


Public Class Form1

    Dim hbitmap As IntPtr

    Private WSQ_library_native_methods As WSQImageLibraryNativeMethods
    Private input_data_stream As Byte()
    Private input_data_stream2 As Byte()
    Private output_data_stream As Byte()
    Private output_data_stream2 As Byte()
    Private pwidth As Int32
    Private pheight As Int32
    Private ppi As Int32
    Private comment_text As String
    Private bitrate As Double


    'To call functions from WSQ_library.dll
    'you can use the methods from wrapper class WSQImageLibraryNativeMethods
    'or you can use function prototypes provided below 

    <DllImport("WSQ_libraryCE.dll", CharSet:=CharSet.Unicode)> _
    Shared Function CreateBMPFromFile(ByVal lpszFileName As String) As IntPtr
    End Function

    <DllImport("WSQ_libraryCE.dll", CharSet:=CharSet.Unicode)> _
    Shared Function SaveBMPToFile(ByVal hBitmap As IntPtr, ByVal lpszFileName As String, ByVal ifiletype As Short) As Int32
    End Function

    <DllImport("WSQ_libraryCE.dll", CharSet:=CharSet.Unicode)> _
    Shared Sub RegisterWSQ()
    End Sub

    <DllImport("WSQ_libraryCE.dll", CharSet:=CharSet.Unicode)> _
    Shared Sub SetShowFilePropertiesDialog(ByVal file_properties_dialog As Int32)
    End Sub

    <DllImport("WSQ_libraryCE.dll", CharSet:=CharSet.Unicode)> _
    Shared Sub ShowFileConverter()
    End Sub

    <DllImport("WSQ_libraryCE.dll", CharSet:=CharSet.Unicode)> _
    Shared Function ConvertHBITMAPtoGrayScale256(ByVal hBitmap As IntPtr) As IntPtr
    End Function

    <DllImport("WSQ_libraryCE.dll", CharSet:=CharSet.Unicode)> _
    Shared Function SaveHBITMAPtoFileAsGrayScale256BMP(ByVal hBitmap As IntPtr, ByVal lpszFileName As String) As Int32
    End Function

    <DllImport("WSQ_libraryCE.dll", CharSet:=CharSet.Unicode)> _
    Shared Function GenerateWSQLibrarySerialNumber() As String
    End Function

    <DllImport("WSQ_libraryCE.dll", CharSet:=CharSet.Unicode)> _
    Shared Function UnlockWSQLibrary(ByVal authorizationcode As String) As Int32
    End Function



    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        comment_text = String.Empty 'need to initialize comment_text in order to avoid crashing
        WSQ_library_native_methods = New WSQImageLibraryNativeMethods
    End Sub

    Private Sub buttonOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonOpen.Click

        '        OpenFileDialog1.Filter = "All images|*.wsq;*.bmp;*.tiff;*.tif;*.jpg;*.jpeg;*.jp2;*.jpc;" & _
        '"*.png;*.gif;*.tga;*.pcx;*.ppm;*.pgm;*.ico;*.wmf;*.wbmp;*.ska;*.mng;*.pnm;*.ras;*.raw;|" & _
        '"FBI's Wavelet Scalar Quantization (*.wsq)|*.wsq|" & _
        '"Windows Bitmap Graphics (*.bmp)|*.bmp|" & _
        '"Macintosh Tagged Information File Format images (*.tiff)|*.tiff|" & _
        '"PC Tagged Information File Format images (*.tif)|*.tif|" & _
        '"Joint Photographic Experts Group images (*.jpg)|*.jpg|" & _
        '"Joint Photographic Experts Group images (*.jpeg)|*.jpeg|" & _
        '"JPEG2000 Part 1 images (*.jp2)|*.jp2|" & _
        '"JPEG2000 Code Stream images (*.jpc)|*.jpc|" & _
        '"Portable Network Graphics images (*.png)|*.png|" & _
        '"Compuserve Graphic Interchange Format images (*.gif)|*.gif|" & _
        '"Truevision Targa Graphic images (*.tga )|*.tga|" & _
        '"ZSoft Paintbrush images (PC Paintbrush Bitmap Graphic) (*.pcx)|*.pcx|" & _
        '"Portable Pixel Map Images (*.ppm)|*.ppm|" & _
        '"Portable Gray Map Images (*.pgm)|*.pgm|" & _
        '"Windows Icons (*.ico)|*.ico|" & _
        '"Windows Metafiles (*.wmf)|*.wmf|" & _
        '"Wireless Bitmap File Format (*.wbmp)|*.wbmp|" & _
        '"SKA Format images (*.ska)|*.ska|" & _
        '"Multi-image Network Graphic Animation (*.mng)|*.mng|" & _
        '"PBM Portable Any Map Graphic Bitmap (*.pnm)|*.pnm|" & _
        '"Sun Graphic (*.ras)|*.ras|" & _
        '"RAW Graphic (*.raw)|*.raw"

        OpenFileDialog1.Filter = "All images|*.wsq;*.bmp;*.jpg;*.png;*.gif;|" & _
"WSQ Files (*.wsq)|*.wsq|" & _
"BMP Files (*.bmp)|*.bmp|" & _
"JPG Files (*.jpg)|*.jpg|" & _
"PNG Files (*.png)|*.png|" & _
"GIF Files (*.gif)|*.gif"


        OpenFileDialog1.FilterIndex = 1

        If (OpenFileDialog1.ShowDialog() <> DialogResult.OK) Then
            Exit Sub
        End If


        'you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
        'hbitmap = CreateBMPFromFile(OpenFileDialog1.FileName)
        hbitmap = WSQ_library_native_methods.pCreateBMPFromFile(OpenFileDialog1.FileName)
        OutputPicture.Image = Bitmap.FromHbitmap(hbitmap)

        buttonSave.Enabled = True


    End Sub


    Private Sub buttonSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonSave.Click

        Dim iResult As Short


        ' Set filters.
        '        SaveFileDialog1.Filter = "WSQ Files (*.wsq)|*.wsq|Windows BMP (*.bmp)|*.bmp|TIFF Files (*.tif)|*.tif|" & _
        '"PNG Files (*.png)|*.png|JPEG Files (*.jpg)|*.jpg|Targa Files (*.tga)|*.tga|RGB Files (*.rgb)|*.rgb|" & _
        '"JPEG-2000 Part-1 (*.jp2)|*.jp2|JPEG-2000 Code Stream (*.jpc)|*.jpc|" & _
        '"GIF Files (*.gif)|*.gif|PNM Files (*.pnm)|*.pnm|RAS Files (*.ras)|*.ras|" & _
        '"MNG Files (*.mng)|*.mng|PCX Files (*.pcx)|*.pcx"

        SaveFileDialog1.Filter = "WSQ Files (*.wsq)|*.wsq|BMP Files (*.bmp)|*.bmp"


        ' Specify default filter.
        SaveFileDialog1.FilterIndex = 1

        SaveFileDialog1.FileName = ""


        If (SaveFileDialog1.ShowDialog() <> DialogResult.OK) Then
            Exit Sub
        End If


        'you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
        'SetShowFilePropertiesDialog(1)
        WSQ_library_native_methods.pSetShowFilePropertiesDialog(1)

        'you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
        'iResult = SaveBMPToFile((New Bitmap(OutputPicture.Image)).GetHbitmap(), SaveFileDialog1.FileName, SaveFileDialog1.FilterIndex)
        iResult = WSQ_library_native_methods.pSaveBMPToFile((New Bitmap(OutputPicture.Image)).GetHbitmap(), SaveFileDialog1.FileName, SaveFileDialog1.FilterIndex)

        'Dim objBitmap As Bitmap
        'objBitmap = OutputPicture.Image
        'iResult = SaveBMPToFile(objBitmap.GetHbitmap(), SaveFileDialog1.FileName, SaveFileDialog1.FilterIndex)

    End Sub

    Private Sub buttonWSQtoStream_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonWSQtoStream.Click



        Dim OpenFileDialog1 As OpenFileDialog = New OpenFileDialog
        OpenFileDialog1.Filter = "FBI Wavelet Scalar Quantization (*.wsq)|*.wsq"
        OpenFileDialog1.FilterIndex = 1

        If (OpenFileDialog1.ShowDialog <> DialogResult.OK) Then
            Exit Sub
        End If

        Dim fInfo As IO.FileInfo = New IO.FileInfo(OpenFileDialog1.FileName)
        Dim input_stream_length As Long = fInfo.Length
        Dim fStream As IO.FileStream = New IO.FileStream(OpenFileDialog1.FileName, IO.FileMode.Open, IO.FileAccess.Read)
        Dim br As IO.BinaryReader = New IO.BinaryReader(fStream)

        input_data_stream = br.ReadBytes(input_stream_length)
        WSQ_library_native_methods.pWSQ_decode_stream(input_data_stream, input_stream_length, output_data_stream, _
                pwidth, pheight, ppi, comment_text)

        Dim output_data_stream_length As Integer = pheight * pwidth


        'Converts WSQ compressed byte array into HBITMAP for showing on screen
        hbitmap = WSQ_library_native_methods.pCreateBMPFromWSQByteArray(input_data_stream, input_stream_length)
        OutputPicture.Image = Bitmap.FromHbitmap(hbitmap)

        ' Saves WSQ compressed byte array to an image file.
        WSQ_library_native_methods.pSaveWSQByteArrayToImageFile(input_data_stream, input_stream_length, "\\Storage Card\\output.jpg", 5)


        MsgBox("WSQ file was loaded into memory stream and decompressed into another memory stream." & vbCrLf & _
            "Now please press button " & ControlChars.Quote & "stream -> WSQ" & ControlChars.Quote & _
            " to compress memory stream and save it to file." & vbCrLf & _
            "WSQ compressed byte array was converted to HBITMAP for showing on screen.")

        br.Close()
        fStream.Close()

        buttonStreamToWSQ.Enabled = True


    End Sub

    Private Sub buttonStreamToWSQ_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonStreamToWSQ.Click

        Dim SaveFileDialog1 As SaveFileDialog = New SaveFileDialog
        SaveFileDialog1.Filter = "WSQ Files (*.wsq)|*.wsq"
        SaveFileDialog1.FilterIndex = 1
        If (SaveFileDialog1.ShowDialog <> DialogResult.OK) Then
            Exit Sub
        End If

        bitrate = 0.75
        ppi = 500
        comment_text = "Cognaxon"

        ReDim input_data_stream2(pwidth * pheight)

        Dim row, row2, pixel_number, pixel_number2 As Integer

        'MAKE A MIRRORED/FLIPPED IMAGE (UP<->DOWN and LEFT<->RIGHT)
        For y As Integer = 0 To pheight - 1 Step 1
            row = pwidth * y
            row2 = pwidth * (pheight - y - 1)

            For x As Integer = 0 To pwidth - 1 Step 1
                pixel_number = row + x
                pixel_number2 = row2 + (pwidth - x - 1)
                input_data_stream2(pixel_number2) = output_data_stream(pixel_number)
            Next x
        Next y

        Dim compressedLength As Integer

        WSQ_library_native_methods.pWSQ_encode_stream(input_data_stream2, pwidth, pheight, _
            bitrate, ppi, comment_text, output_data_stream2, compressedLength)

        Dim fStream As IO.FileStream = New IO.FileStream(SaveFileDialog1.FileName, IO.FileMode.CreateNew)
        Dim bw As IO.BinaryWriter = New IO.BinaryWriter(fStream)

        bw.Write(output_data_stream2)

        bw.Close()
        fStream.Close()

        MsgBox("Memory stream was compressed into another memory stream and saved to WSQ file." & vbCrLf & _
           "Now please press button " & ControlChars.Quote & "Open" & ControlChars.Quote & _
           ", select the saved file, open it and have a look at the" & vbCrLf & _
           "results of memory stream processing. The processed image is mirrored/flipped" & vbCrLf & _
           "(UP<->DOWN and LEFT<->RIGHT).")


    End Sub

    Private Sub buttonRegister_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonRegister.Click
        WSQ_library_native_methods.pGenerateWSQLibrarySerialNumber()
        MsgBox("Serial number was saved to file wsq_ce_serial_number.txt.")
    End Sub

    Private Sub buttonUnlock_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonUnlock.Click
        Dim ret As Int32

        ret = WSQ_library_native_methods.pUnlockWSQLibrary("")
        If (ret = 1) Then
            MsgBox("WSQ image library" & vbCrLf & "registration succeeded.")
        Else
            MsgBox("WSQ image library" & vbCrLf & "registration failed.")
        End If

    End Sub


End Class
